Index: XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp	(revision 369)
+++ XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp	(revision 415)
@@ -51,4 +51,23 @@
     if(!string_copy(axis_hdl->name.getValue(),name , name_size))
       ERROR("void cxios_get_axis_name(axis_Ptr axis_hdl, char * name, int name_size)", <<"Input string is to short");
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
+  void cxios_set_axis_positive(axis_Ptr axis_hdl, const char * positive, int positive_size)
+  {
+    std::string positive_str;
+    if(!cstr2string(positive, positive_size, positive_str)) return;
+     CTimer::get("XIOS").resume();
+    axis_hdl->positive.fromString(positive_str);
+    axis_hdl->sendAttributToServer(axis_hdl->positive);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_axis_positive(axis_Ptr axis_hdl, char * positive, int positive_size)
+  {
+     CTimer::get("XIOS").resume();
+    if(!string_copy(axis_hdl->positive.getStringValue(),positive , positive_size))
+      ERROR("void cxios_get_axis_positive(axis_Ptr axis_hdl, char * positive, int positive_size)", <<"Input string is to short");
      CTimer::get("XIOS").suspend();
   }
Index: XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp	(revision 369)
+++ XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp	(revision 415)
@@ -74,4 +74,23 @@
   
   
+  void cxios_set_axisgroup_positive(axisgroup_Ptr axisgroup_hdl, const char * positive, int positive_size)
+  {
+    std::string positive_str;
+    if(!cstr2string(positive, positive_size, positive_str)) return;
+     CTimer::get("XIOS").resume();
+    axisgroup_hdl->positive.fromString(positive_str);
+    axisgroup_hdl->sendAttributToServer(axisgroup_hdl->positive);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_axisgroup_positive(axisgroup_Ptr axisgroup_hdl, char * positive, int positive_size)
+  {
+     CTimer::get("XIOS").resume();
+    if(!string_copy(axisgroup_hdl->positive.getStringValue(),positive , positive_size))
+      ERROR("void cxios_get_axisgroup_positive(axisgroup_Ptr axisgroup_hdl, char * positive, int positive_size)", <<"Input string is to short");
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   void cxios_set_axisgroup_size(axisgroup_Ptr axisgroup_hdl, int size)
   {
Index: XIOS/trunk/src/interface/c_attr/icfile_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icfile_attr.cpp	(revision 369)
+++ XIOS/trunk/src/interface/c_attr/icfile_attr.cpp	(revision 415)
@@ -50,4 +50,18 @@
   
   
+  void cxios_set_file_min_digits(file_Ptr file_hdl, int min_digits)
+  {
+     CTimer::get("XIOS").resume();
+    file_hdl->min_digits.setValue(min_digits);
+    file_hdl->sendAttributToServer(file_hdl->min_digits);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_file_min_digits(file_Ptr file_hdl, int* min_digits)
+  {
+    *min_digits = file_hdl->min_digits.getValue();
+  }
+  
+  
   void cxios_set_file_name(file_Ptr file_hdl, const char * name, int name_size)
   {
Index: XIOS/trunk/src/interface/c_attr/icfilegroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icfilegroup_attr.cpp	(revision 369)
+++ XIOS/trunk/src/interface/c_attr/icfilegroup_attr.cpp	(revision 415)
@@ -69,4 +69,18 @@
   
   
+  void cxios_set_filegroup_min_digits(filegroup_Ptr filegroup_hdl, int min_digits)
+  {
+     CTimer::get("XIOS").resume();
+    filegroup_hdl->min_digits.setValue(min_digits);
+    filegroup_hdl->sendAttributToServer(filegroup_hdl->min_digits);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_filegroup_min_digits(filegroup_Ptr filegroup_hdl, int* min_digits)
+  {
+    *min_digits = filegroup_hdl->min_digits.getValue();
+  }
+  
+  
   void cxios_set_filegroup_name(filegroup_Ptr filegroup_hdl, const char * name, int name_size)
   {
Index: XIOS/trunk/src/interface/c_attr/icgrid_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icgrid_attr.cpp	(revision 369)
+++ XIOS/trunk/src/interface/c_attr/icgrid_attr.cpp	(revision 415)
@@ -74,4 +74,20 @@
   
   
+  void cxios_set_grid_mask(grid_Ptr grid_hdl, bool* mask, int extent1, int extent2, int extent3)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<bool,3> tmp(mask,shape(extent1,extent2,extent3),neverDeleteData) ;
+    grid_hdl->mask.reference(tmp.copy());
+    grid_hdl->sendAttributToServer(grid_hdl->mask);
+  }
+  
+  void cxios_get_grid_mask(grid_Ptr grid_hdl, bool* mask, int extent1, int extent2, int extent3)
+  {
+    CArray<bool,3> tmp(mask,shape(extent1,extent2,extent3),neverDeleteData) ;
+    tmp=grid_hdl->mask ;
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   void cxios_set_grid_name(grid_Ptr grid_hdl, const char * name, int name_size)
   {
Index: XIOS/trunk/src/interface/c_attr/icgridgroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icgridgroup_attr.cpp	(revision 369)
+++ XIOS/trunk/src/interface/c_attr/icgridgroup_attr.cpp	(revision 415)
@@ -93,4 +93,20 @@
   
   
+  void cxios_set_gridgroup_mask(gridgroup_Ptr gridgroup_hdl, bool* mask, int extent1, int extent2, int extent3)
+  {
+    CTimer::get("XIOS").resume();
+    CArray<bool,3> tmp(mask,shape(extent1,extent2,extent3),neverDeleteData) ;
+    gridgroup_hdl->mask.reference(tmp.copy());
+    gridgroup_hdl->sendAttributToServer(gridgroup_hdl->mask);
+  }
+  
+  void cxios_get_gridgroup_mask(gridgroup_Ptr gridgroup_hdl, bool* mask, int extent1, int extent2, int extent3)
+  {
+    CArray<bool,3> tmp(mask,shape(extent1,extent2,extent3),neverDeleteData) ;
+    tmp=gridgroup_hdl->mask ;
+     CTimer::get("XIOS").suspend();
+  }
+  
+  
   void cxios_set_gridgroup_name(gridgroup_Ptr gridgroup_hdl, const char * name, int name_size)
   {