Index: XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp	(revision 415)
+++ XIOS/trunk/src/interface/c_attr/icaxis_attr.cpp	(revision 416)
@@ -132,8 +132,10 @@
     axis_hdl->value.reference(tmp.copy());
     axis_hdl->sendAttributToServer(axis_hdl->value);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_axis_value(axis_Ptr axis_hdl, double* value, int extent1)
   {
+    CTimer::get("XIOS").resume();
     CArray<double,1> tmp(value,shape(extent1),neverDeleteData) ;
     tmp=axis_hdl->value ;
Index: XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp	(revision 415)
+++ XIOS/trunk/src/interface/c_attr/icaxisgroup_attr.cpp	(revision 416)
@@ -151,8 +151,10 @@
     axisgroup_hdl->value.reference(tmp.copy());
     axisgroup_hdl->sendAttributToServer(axisgroup_hdl->value);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_axisgroup_value(axisgroup_Ptr axisgroup_hdl, double* value, int extent1)
   {
+    CTimer::get("XIOS").resume();
     CArray<double,1> tmp(value,shape(extent1),neverDeleteData) ;
     tmp=axisgroup_hdl->value ;
Index: XIOS/trunk/src/interface/c_attr/icdomain_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icdomain_attr.cpp	(revision 415)
+++ XIOS/trunk/src/interface/c_attr/icdomain_attr.cpp	(revision 416)
@@ -37,8 +37,10 @@
     domain_hdl->data_i_index.reference(tmp.copy());
     domain_hdl->sendAttributToServer(domain_hdl->data_i_index);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_domain_data_i_index(domain_Ptr domain_hdl, int* data_i_index, int extent1)
   {
+    CTimer::get("XIOS").resume();
     CArray<int,1> tmp(data_i_index,shape(extent1),neverDeleteData) ;
     tmp=domain_hdl->data_i_index ;
@@ -67,8 +69,10 @@
     domain_hdl->data_j_index.reference(tmp.copy());
     domain_hdl->sendAttributToServer(domain_hdl->data_j_index);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_domain_data_j_index(domain_Ptr domain_hdl, int* data_j_index, int extent1)
   {
+    CTimer::get("XIOS").resume();
     CArray<int,1> tmp(data_j_index,shape(extent1),neverDeleteData) ;
     tmp=domain_hdl->data_j_index ;
@@ -214,8 +218,10 @@
     domain_hdl->latvalue.reference(tmp.copy());
     domain_hdl->sendAttributToServer(domain_hdl->latvalue);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_domain_latvalue(domain_Ptr domain_hdl, double* latvalue, int extent1)
   {
+    CTimer::get("XIOS").resume();
     CArray<double,1> tmp(latvalue,shape(extent1),neverDeleteData) ;
     tmp=domain_hdl->latvalue ;
@@ -249,8 +255,10 @@
     domain_hdl->lonvalue.reference(tmp.copy());
     domain_hdl->sendAttributToServer(domain_hdl->lonvalue);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_domain_lonvalue(domain_Ptr domain_hdl, double* lonvalue, int extent1)
   {
+    CTimer::get("XIOS").resume();
     CArray<double,1> tmp(lonvalue,shape(extent1),neverDeleteData) ;
     tmp=domain_hdl->lonvalue ;
@@ -265,8 +273,10 @@
     domain_hdl->mask.reference(tmp.copy());
     domain_hdl->sendAttributToServer(domain_hdl->mask);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_domain_mask(domain_Ptr domain_hdl, bool* mask, int extent1, int extent2)
   {
+    CTimer::get("XIOS").resume();
     CArray<bool,2> tmp(mask,shape(extent1,extent2),neverDeleteData) ;
     tmp=domain_hdl->mask ;
Index: XIOS/trunk/src/interface/c_attr/icdomaingroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icdomaingroup_attr.cpp	(revision 415)
+++ XIOS/trunk/src/interface/c_attr/icdomaingroup_attr.cpp	(revision 416)
@@ -37,8 +37,10 @@
     domaingroup_hdl->data_i_index.reference(tmp.copy());
     domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_i_index);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_domaingroup_data_i_index(domaingroup_Ptr domaingroup_hdl, int* data_i_index, int extent1)
   {
+    CTimer::get("XIOS").resume();
     CArray<int,1> tmp(data_i_index,shape(extent1),neverDeleteData) ;
     tmp=domaingroup_hdl->data_i_index ;
@@ -67,8 +69,10 @@
     domaingroup_hdl->data_j_index.reference(tmp.copy());
     domaingroup_hdl->sendAttributToServer(domaingroup_hdl->data_j_index);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_domaingroup_data_j_index(domaingroup_Ptr domaingroup_hdl, int* data_j_index, int extent1)
   {
+    CTimer::get("XIOS").resume();
     CArray<int,1> tmp(data_j_index,shape(extent1),neverDeleteData) ;
     tmp=domaingroup_hdl->data_j_index ;
@@ -233,8 +237,10 @@
     domaingroup_hdl->latvalue.reference(tmp.copy());
     domaingroup_hdl->sendAttributToServer(domaingroup_hdl->latvalue);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_domaingroup_latvalue(domaingroup_Ptr domaingroup_hdl, double* latvalue, int extent1)
   {
+    CTimer::get("XIOS").resume();
     CArray<double,1> tmp(latvalue,shape(extent1),neverDeleteData) ;
     tmp=domaingroup_hdl->latvalue ;
@@ -268,8 +274,10 @@
     domaingroup_hdl->lonvalue.reference(tmp.copy());
     domaingroup_hdl->sendAttributToServer(domaingroup_hdl->lonvalue);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_domaingroup_lonvalue(domaingroup_Ptr domaingroup_hdl, double* lonvalue, int extent1)
   {
+    CTimer::get("XIOS").resume();
     CArray<double,1> tmp(lonvalue,shape(extent1),neverDeleteData) ;
     tmp=domaingroup_hdl->lonvalue ;
@@ -284,8 +292,10 @@
     domaingroup_hdl->mask.reference(tmp.copy());
     domaingroup_hdl->sendAttributToServer(domaingroup_hdl->mask);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_domaingroup_mask(domaingroup_Ptr domaingroup_hdl, bool* mask, int extent1, int extent2)
   {
+    CTimer::get("XIOS").resume();
     CArray<bool,2> tmp(mask,shape(extent1,extent2),neverDeleteData) ;
     tmp=domaingroup_hdl->mask ;
Index: XIOS/trunk/src/interface/c_attr/icgrid_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icgrid_attr.cpp	(revision 415)
+++ XIOS/trunk/src/interface/c_attr/icgrid_attr.cpp	(revision 416)
@@ -80,8 +80,10 @@
     grid_hdl->mask.reference(tmp.copy());
     grid_hdl->sendAttributToServer(grid_hdl->mask);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_grid_mask(grid_Ptr grid_hdl, bool* mask, int extent1, int extent2, int extent3)
   {
+    CTimer::get("XIOS").resume();
     CArray<bool,3> tmp(mask,shape(extent1,extent2,extent3),neverDeleteData) ;
     tmp=grid_hdl->mask ;
Index: XIOS/trunk/src/interface/c_attr/icgridgroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icgridgroup_attr.cpp	(revision 415)
+++ XIOS/trunk/src/interface/c_attr/icgridgroup_attr.cpp	(revision 416)
@@ -99,8 +99,10 @@
     gridgroup_hdl->mask.reference(tmp.copy());
     gridgroup_hdl->sendAttributToServer(gridgroup_hdl->mask);
+     CTimer::get("XIOS").suspend();
   }
   
   void cxios_get_gridgroup_mask(gridgroup_Ptr gridgroup_hdl, bool* mask, int extent1, int extent2, int extent3)
   {
+    CTimer::get("XIOS").resume();
     CArray<bool,3> tmp(mask,shape(extent1,extent2,extent3),neverDeleteData) ;
     tmp=gridgroup_hdl->mask ;