Index: XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90	(revision 326)
+++ XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90	(revision 432)
@@ -569,3 +569,405 @@
   END SUBROUTINE xios(get_domaingroup_attr_hdl_)
   
+  SUBROUTINE xios(is_defined_domaingroup_attr)  &
+    ( domaingroup_id, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index  &
+    , data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin, jend, latvalue, long_name  &
+    , lonvalue, mask, name, ni, ni_glo, nj, nj_glo, standard_name, zoom_ibegin, zoom_ibegin_loc  &
+    , zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj, zoom_nj_loc )
+    
+    IMPLICIT NONE
+      TYPE(txios(domaingroup))  :: domaingroup_hdl
+      CHARACTER(LEN=*), INTENT(IN) ::domaingroup_id
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_dim
+      LOGICAL(KIND=C_BOOL) :: data_dim_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_i_index
+      LOGICAL(KIND=C_BOOL) :: data_i_index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_ibegin
+      LOGICAL(KIND=C_BOOL) :: data_ibegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_j_index
+      LOGICAL(KIND=C_BOOL) :: data_j_index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_jbegin
+      LOGICAL(KIND=C_BOOL) :: data_jbegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_n_index
+      LOGICAL(KIND=C_BOOL) :: data_n_index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_ni
+      LOGICAL(KIND=C_BOOL) :: data_ni_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_nj
+      LOGICAL(KIND=C_BOOL) :: data_nj_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: domain_group_ref
+      LOGICAL(KIND=C_BOOL) :: domain_group_ref_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: group_ref
+      LOGICAL(KIND=C_BOOL) :: group_ref_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: ibegin
+      LOGICAL(KIND=C_BOOL) :: ibegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: iend
+      LOGICAL(KIND=C_BOOL) :: iend_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: jbegin
+      LOGICAL(KIND=C_BOOL) :: jbegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: jend
+      LOGICAL(KIND=C_BOOL) :: jend_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue
+      LOGICAL(KIND=C_BOOL) :: latvalue_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: long_name
+      LOGICAL(KIND=C_BOOL) :: long_name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: lonvalue
+      LOGICAL(KIND=C_BOOL) :: lonvalue_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask
+      LOGICAL(KIND=C_BOOL) :: mask_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: name
+      LOGICAL(KIND=C_BOOL) :: name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: ni
+      LOGICAL(KIND=C_BOOL) :: ni_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: ni_glo
+      LOGICAL(KIND=C_BOOL) :: ni_glo_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: nj
+      LOGICAL(KIND=C_BOOL) :: nj_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: nj_glo
+      LOGICAL(KIND=C_BOOL) :: nj_glo_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: standard_name
+      LOGICAL(KIND=C_BOOL) :: standard_name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin
+      LOGICAL(KIND=C_BOOL) :: zoom_ibegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin_loc
+      LOGICAL(KIND=C_BOOL) :: zoom_ibegin_loc_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin
+      LOGICAL(KIND=C_BOOL) :: zoom_jbegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin_loc
+      LOGICAL(KIND=C_BOOL) :: zoom_jbegin_loc_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni
+      LOGICAL(KIND=C_BOOL) :: zoom_ni_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni_loc
+      LOGICAL(KIND=C_BOOL) :: zoom_ni_loc_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj
+      LOGICAL(KIND=C_BOOL) :: zoom_nj_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj_loc
+      LOGICAL(KIND=C_BOOL) :: zoom_nj_loc_tmp
+      
+      CALL xios(get_domaingroup_handle)(domaingroup_id,domaingroup_hdl)
+      CALL xios(is_defined_domaingroup_attr_hdl_)   &
+      ( domaingroup_hdl, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index  &
+      , data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin, jend, latvalue, long_name  &
+      , lonvalue, mask, name, ni, ni_glo, nj, nj_glo, standard_name, zoom_ibegin, zoom_ibegin_loc  &
+      , zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj, zoom_nj_loc )
+    
+  END SUBROUTINE xios(is_defined_domaingroup_attr)
+  
+  SUBROUTINE xios(is_defined_domaingroup_attr_hdl)  &
+    ( domaingroup_hdl, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index  &
+    , data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin, jend, latvalue, long_name  &
+    , lonvalue, mask, name, ni, ni_glo, nj, nj_glo, standard_name, zoom_ibegin, zoom_ibegin_loc  &
+    , zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj, zoom_nj_loc )
+    
+    IMPLICIT NONE
+      TYPE(txios(domaingroup)) , INTENT(IN) :: domaingroup_hdl
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_dim
+      LOGICAL(KIND=C_BOOL) :: data_dim_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_i_index
+      LOGICAL(KIND=C_BOOL) :: data_i_index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_ibegin
+      LOGICAL(KIND=C_BOOL) :: data_ibegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_j_index
+      LOGICAL(KIND=C_BOOL) :: data_j_index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_jbegin
+      LOGICAL(KIND=C_BOOL) :: data_jbegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_n_index
+      LOGICAL(KIND=C_BOOL) :: data_n_index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_ni
+      LOGICAL(KIND=C_BOOL) :: data_ni_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_nj
+      LOGICAL(KIND=C_BOOL) :: data_nj_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: domain_group_ref
+      LOGICAL(KIND=C_BOOL) :: domain_group_ref_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: group_ref
+      LOGICAL(KIND=C_BOOL) :: group_ref_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: ibegin
+      LOGICAL(KIND=C_BOOL) :: ibegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: iend
+      LOGICAL(KIND=C_BOOL) :: iend_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: jbegin
+      LOGICAL(KIND=C_BOOL) :: jbegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: jend
+      LOGICAL(KIND=C_BOOL) :: jend_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue
+      LOGICAL(KIND=C_BOOL) :: latvalue_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: long_name
+      LOGICAL(KIND=C_BOOL) :: long_name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: lonvalue
+      LOGICAL(KIND=C_BOOL) :: lonvalue_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask
+      LOGICAL(KIND=C_BOOL) :: mask_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: name
+      LOGICAL(KIND=C_BOOL) :: name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: ni
+      LOGICAL(KIND=C_BOOL) :: ni_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: ni_glo
+      LOGICAL(KIND=C_BOOL) :: ni_glo_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: nj
+      LOGICAL(KIND=C_BOOL) :: nj_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: nj_glo
+      LOGICAL(KIND=C_BOOL) :: nj_glo_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: standard_name
+      LOGICAL(KIND=C_BOOL) :: standard_name_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin
+      LOGICAL(KIND=C_BOOL) :: zoom_ibegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin_loc
+      LOGICAL(KIND=C_BOOL) :: zoom_ibegin_loc_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin
+      LOGICAL(KIND=C_BOOL) :: zoom_jbegin_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin_loc
+      LOGICAL(KIND=C_BOOL) :: zoom_jbegin_loc_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni
+      LOGICAL(KIND=C_BOOL) :: zoom_ni_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni_loc
+      LOGICAL(KIND=C_BOOL) :: zoom_ni_loc_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj
+      LOGICAL(KIND=C_BOOL) :: zoom_nj_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj_loc
+      LOGICAL(KIND=C_BOOL) :: zoom_nj_loc_tmp
+      
+      CALL xios(is_defined_domaingroup_attr_hdl_)  &
+      ( domaingroup_hdl, data_dim, data_i_index, data_ibegin, data_j_index, data_jbegin, data_n_index  &
+      , data_ni, data_nj, domain_group_ref, group_ref, ibegin, iend, jbegin, jend, latvalue, long_name  &
+      , lonvalue, mask, name, ni, ni_glo, nj, nj_glo, standard_name, zoom_ibegin, zoom_ibegin_loc  &
+      , zoom_jbegin, zoom_jbegin_loc, zoom_ni, zoom_ni_loc, zoom_nj, zoom_nj_loc )
+    
+  END SUBROUTINE xios(is_defined_domaingroup_attr_hdl)
+  
+  SUBROUTINE xios(is_defined_domaingroup_attr_hdl_)   &
+    ( domaingroup_hdl, data_dim_, data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_n_index_  &
+    , data_ni_, data_nj_, domain_group_ref_, group_ref_, ibegin_, iend_, jbegin_, jend_, latvalue_  &
+    , long_name_, lonvalue_, mask_, name_, ni_, ni_glo_, nj_, nj_glo_, standard_name_, zoom_ibegin_  &
+    , zoom_ibegin_loc_, zoom_jbegin_, zoom_jbegin_loc_, zoom_ni_, zoom_ni_loc_, zoom_nj_, zoom_nj_loc_  &
+     )
+    
+    IMPLICIT NONE
+      TYPE(txios(domaingroup)) , INTENT(IN) :: domaingroup_hdl
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_dim_
+      LOGICAL(KIND=C_BOOL) :: data_dim__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_i_index_
+      LOGICAL(KIND=C_BOOL) :: data_i_index__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_ibegin_
+      LOGICAL(KIND=C_BOOL) :: data_ibegin__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_j_index_
+      LOGICAL(KIND=C_BOOL) :: data_j_index__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_jbegin_
+      LOGICAL(KIND=C_BOOL) :: data_jbegin__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_n_index_
+      LOGICAL(KIND=C_BOOL) :: data_n_index__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_ni_
+      LOGICAL(KIND=C_BOOL) :: data_ni__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: data_nj_
+      LOGICAL(KIND=C_BOOL) :: data_nj__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: domain_group_ref_
+      LOGICAL(KIND=C_BOOL) :: domain_group_ref__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: group_ref_
+      LOGICAL(KIND=C_BOOL) :: group_ref__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: ibegin_
+      LOGICAL(KIND=C_BOOL) :: ibegin__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: iend_
+      LOGICAL(KIND=C_BOOL) :: iend__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: jbegin_
+      LOGICAL(KIND=C_BOOL) :: jbegin__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: jend_
+      LOGICAL(KIND=C_BOOL) :: jend__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: latvalue_
+      LOGICAL(KIND=C_BOOL) :: latvalue__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: long_name_
+      LOGICAL(KIND=C_BOOL) :: long_name__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: lonvalue_
+      LOGICAL(KIND=C_BOOL) :: lonvalue__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask_
+      LOGICAL(KIND=C_BOOL) :: mask__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: name_
+      LOGICAL(KIND=C_BOOL) :: name__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: ni_
+      LOGICAL(KIND=C_BOOL) :: ni__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: ni_glo_
+      LOGICAL(KIND=C_BOOL) :: ni_glo__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: nj_
+      LOGICAL(KIND=C_BOOL) :: nj__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: nj_glo_
+      LOGICAL(KIND=C_BOOL) :: nj_glo__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: standard_name_
+      LOGICAL(KIND=C_BOOL) :: standard_name__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin_
+      LOGICAL(KIND=C_BOOL) :: zoom_ibegin__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ibegin_loc_
+      LOGICAL(KIND=C_BOOL) :: zoom_ibegin_loc__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin_
+      LOGICAL(KIND=C_BOOL) :: zoom_jbegin__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_jbegin_loc_
+      LOGICAL(KIND=C_BOOL) :: zoom_jbegin_loc__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni_
+      LOGICAL(KIND=C_BOOL) :: zoom_ni__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_ni_loc_
+      LOGICAL(KIND=C_BOOL) :: zoom_ni_loc__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj_
+      LOGICAL(KIND=C_BOOL) :: zoom_nj__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: zoom_nj_loc_
+      LOGICAL(KIND=C_BOOL) :: zoom_nj_loc__tmp
+      
+      IF (PRESENT(data_dim_)) THEN
+        data_dim__tmp=cxios_is_defined_domaingroup_data_dim(domaingroup_hdl%daddr)
+        data_dim_=data_dim__tmp
+      ENDIF
+      
+      IF (PRESENT(data_i_index_)) THEN
+        data_i_index__tmp=cxios_is_defined_domaingroup_data_i_index(domaingroup_hdl%daddr)
+        data_i_index_=data_i_index__tmp
+      ENDIF
+      
+      IF (PRESENT(data_ibegin_)) THEN
+        data_ibegin__tmp=cxios_is_defined_domaingroup_data_ibegin(domaingroup_hdl%daddr)
+        data_ibegin_=data_ibegin__tmp
+      ENDIF
+      
+      IF (PRESENT(data_j_index_)) THEN
+        data_j_index__tmp=cxios_is_defined_domaingroup_data_j_index(domaingroup_hdl%daddr)
+        data_j_index_=data_j_index__tmp
+      ENDIF
+      
+      IF (PRESENT(data_jbegin_)) THEN
+        data_jbegin__tmp=cxios_is_defined_domaingroup_data_jbegin(domaingroup_hdl%daddr)
+        data_jbegin_=data_jbegin__tmp
+      ENDIF
+      
+      IF (PRESENT(data_n_index_)) THEN
+        data_n_index__tmp=cxios_is_defined_domaingroup_data_n_index(domaingroup_hdl%daddr)
+        data_n_index_=data_n_index__tmp
+      ENDIF
+      
+      IF (PRESENT(data_ni_)) THEN
+        data_ni__tmp=cxios_is_defined_domaingroup_data_ni(domaingroup_hdl%daddr)
+        data_ni_=data_ni__tmp
+      ENDIF
+      
+      IF (PRESENT(data_nj_)) THEN
+        data_nj__tmp=cxios_is_defined_domaingroup_data_nj(domaingroup_hdl%daddr)
+        data_nj_=data_nj__tmp
+      ENDIF
+      
+      IF (PRESENT(domain_group_ref_)) THEN
+        domain_group_ref__tmp=cxios_is_defined_domaingroup_domain_group_ref(domaingroup_hdl%daddr)
+        domain_group_ref_=domain_group_ref__tmp
+      ENDIF
+      
+      IF (PRESENT(group_ref_)) THEN
+        group_ref__tmp=cxios_is_defined_domaingroup_group_ref(domaingroup_hdl%daddr)
+        group_ref_=group_ref__tmp
+      ENDIF
+      
+      IF (PRESENT(ibegin_)) THEN
+        ibegin__tmp=cxios_is_defined_domaingroup_ibegin(domaingroup_hdl%daddr)
+        ibegin_=ibegin__tmp
+      ENDIF
+      
+      IF (PRESENT(iend_)) THEN
+        iend__tmp=cxios_is_defined_domaingroup_iend(domaingroup_hdl%daddr)
+        iend_=iend__tmp
+      ENDIF
+      
+      IF (PRESENT(jbegin_)) THEN
+        jbegin__tmp=cxios_is_defined_domaingroup_jbegin(domaingroup_hdl%daddr)
+        jbegin_=jbegin__tmp
+      ENDIF
+      
+      IF (PRESENT(jend_)) THEN
+        jend__tmp=cxios_is_defined_domaingroup_jend(domaingroup_hdl%daddr)
+        jend_=jend__tmp
+      ENDIF
+      
+      IF (PRESENT(latvalue_)) THEN
+        latvalue__tmp=cxios_is_defined_domaingroup_latvalue(domaingroup_hdl%daddr)
+        latvalue_=latvalue__tmp
+      ENDIF
+      
+      IF (PRESENT(long_name_)) THEN
+        long_name__tmp=cxios_is_defined_domaingroup_long_name(domaingroup_hdl%daddr)
+        long_name_=long_name__tmp
+      ENDIF
+      
+      IF (PRESENT(lonvalue_)) THEN
+        lonvalue__tmp=cxios_is_defined_domaingroup_lonvalue(domaingroup_hdl%daddr)
+        lonvalue_=lonvalue__tmp
+      ENDIF
+      
+      IF (PRESENT(mask_)) THEN
+        mask__tmp=cxios_is_defined_domaingroup_mask(domaingroup_hdl%daddr)
+        mask_=mask__tmp
+      ENDIF
+      
+      IF (PRESENT(name_)) THEN
+        name__tmp=cxios_is_defined_domaingroup_name(domaingroup_hdl%daddr)
+        name_=name__tmp
+      ENDIF
+      
+      IF (PRESENT(ni_)) THEN
+        ni__tmp=cxios_is_defined_domaingroup_ni(domaingroup_hdl%daddr)
+        ni_=ni__tmp
+      ENDIF
+      
+      IF (PRESENT(ni_glo_)) THEN
+        ni_glo__tmp=cxios_is_defined_domaingroup_ni_glo(domaingroup_hdl%daddr)
+        ni_glo_=ni_glo__tmp
+      ENDIF
+      
+      IF (PRESENT(nj_)) THEN
+        nj__tmp=cxios_is_defined_domaingroup_nj(domaingroup_hdl%daddr)
+        nj_=nj__tmp
+      ENDIF
+      
+      IF (PRESENT(nj_glo_)) THEN
+        nj_glo__tmp=cxios_is_defined_domaingroup_nj_glo(domaingroup_hdl%daddr)
+        nj_glo_=nj_glo__tmp
+      ENDIF
+      
+      IF (PRESENT(standard_name_)) THEN
+        standard_name__tmp=cxios_is_defined_domaingroup_standard_name(domaingroup_hdl%daddr)
+        standard_name_=standard_name__tmp
+      ENDIF
+      
+      IF (PRESENT(zoom_ibegin_)) THEN
+        zoom_ibegin__tmp=cxios_is_defined_domaingroup_zoom_ibegin(domaingroup_hdl%daddr)
+        zoom_ibegin_=zoom_ibegin__tmp
+      ENDIF
+      
+      IF (PRESENT(zoom_ibegin_loc_)) THEN
+        zoom_ibegin_loc__tmp=cxios_is_defined_domaingroup_zoom_ibegin_loc(domaingroup_hdl%daddr)
+        zoom_ibegin_loc_=zoom_ibegin_loc__tmp
+      ENDIF
+      
+      IF (PRESENT(zoom_jbegin_)) THEN
+        zoom_jbegin__tmp=cxios_is_defined_domaingroup_zoom_jbegin(domaingroup_hdl%daddr)
+        zoom_jbegin_=zoom_jbegin__tmp
+      ENDIF
+      
+      IF (PRESENT(zoom_jbegin_loc_)) THEN
+        zoom_jbegin_loc__tmp=cxios_is_defined_domaingroup_zoom_jbegin_loc(domaingroup_hdl%daddr)
+        zoom_jbegin_loc_=zoom_jbegin_loc__tmp
+      ENDIF
+      
+      IF (PRESENT(zoom_ni_)) THEN
+        zoom_ni__tmp=cxios_is_defined_domaingroup_zoom_ni(domaingroup_hdl%daddr)
+        zoom_ni_=zoom_ni__tmp
+      ENDIF
+      
+      IF (PRESENT(zoom_ni_loc_)) THEN
+        zoom_ni_loc__tmp=cxios_is_defined_domaingroup_zoom_ni_loc(domaingroup_hdl%daddr)
+        zoom_ni_loc_=zoom_ni_loc__tmp
+      ENDIF
+      
+      IF (PRESENT(zoom_nj_)) THEN
+        zoom_nj__tmp=cxios_is_defined_domaingroup_zoom_nj(domaingroup_hdl%daddr)
+        zoom_nj_=zoom_nj__tmp
+      ENDIF
+      
+      IF (PRESENT(zoom_nj_loc_)) THEN
+        zoom_nj_loc__tmp=cxios_is_defined_domaingroup_zoom_nj_loc(domaingroup_hdl%daddr)
+        zoom_nj_loc_=zoom_nj_loc__tmp
+      ENDIF
+      
+      
+    
+  END SUBROUTINE xios(is_defined_domaingroup_attr_hdl_)
+  
 END MODULE idomaingroup_attr