Index: XIOS/trunk/arch/arch-GCC_LINUX.path
===================================================================
--- XIOS/trunk/arch/arch-GCC_LINUX.path	(revision 414)
+++ XIOS/trunk/arch/arch-GCC_LINUX.path	(revision 440)
@@ -11,5 +11,5 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz"
 
-OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: XIOS/trunk/arch/arch-GCC_MACOSX.path
===================================================================
--- XIOS/trunk/arch/arch-GCC_MACOSX.path	(revision 414)
+++ XIOS/trunk/arch/arch-GCC_MACOSX.path	(revision 440)
@@ -7,5 +7,5 @@
 HDF5_LIB=""
 
-OASIS_INCDIR="-I$(WORKDIR}/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$(WORKDIR}/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: XIOS/trunk/arch/arch-PW6_VARGAS.path
===================================================================
--- XIOS/trunk/arch/arch-PW6_VARGAS.path	(revision 414)
+++ XIOS/trunk/arch/arch-PW6_VARGAS.path	(revision 440)
@@ -11,5 +11,5 @@
 MPI_LIB=""
 
-OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: XIOS/trunk/arch/arch-X64_CURIE.path
===================================================================
--- XIOS/trunk/arch/arch-X64_CURIE.path	(revision 414)
+++ XIOS/trunk/arch/arch-X64_CURIE.path	(revision 440)
@@ -11,6 +11,6 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
 
-OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
 
Index: XIOS/trunk/arch/arch-X64_CURIE_GCC.path
===================================================================
--- XIOS/trunk/arch/arch-X64_CURIE_GCC.path	(revision 414)
+++ XIOS/trunk/arch/arch-X64_CURIE_GCC.path	(revision 440)
@@ -11,5 +11,5 @@
 HDF5_LIB=""
 
-OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: XIOS/trunk/arch/arch-X64_CURIE_PGI.path
===================================================================
--- XIOS/trunk/arch/arch-X64_CURIE_PGI.path	(revision 414)
+++ XIOS/trunk/arch/arch-X64_CURIE_PGI.path	(revision 440)
@@ -11,5 +11,5 @@
 HDF5_LIB=""
 
-OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: XIOS/trunk/arch/arch-X64_CURIE_VAMPIR.path
===================================================================
--- XIOS/trunk/arch/arch-X64_CURIE_VAMPIR.path	(revision 414)
+++ XIOS/trunk/arch/arch-X64_CURIE_VAMPIR.path	(revision 440)
@@ -11,5 +11,5 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
 
-OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: XIOS/trunk/arch/arch-X64_HORUS.path
===================================================================
--- XIOS/trunk/arch/arch-X64_HORUS.path	(revision 414)
+++ XIOS/trunk/arch/arch-X64_HORUS.path	(revision 440)
@@ -11,5 +11,5 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz"
 
-OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: XIOS/trunk/arch/arch-X64_JADE.path
===================================================================
--- XIOS/trunk/arch/arch-X64_JADE.path	(revision 414)
+++ XIOS/trunk/arch/arch-X64_JADE.path	(revision 440)
@@ -11,5 +11,5 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz"
 
-OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: XIOS/trunk/arch/arch-X64_TITANE.path
===================================================================
--- XIOS/trunk/arch/arch-X64_TITANE.path	(revision 414)
+++ XIOS/trunk/arch/arch-X64_TITANE.path	(revision 440)
@@ -11,5 +11,5 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
 
-OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: XIOS/trunk/arch/arch-X64_TITANE_VAMPIR.path
===================================================================
--- XIOS/trunk/arch/arch-X64_TITANE_VAMPIR.path	(revision 414)
+++ XIOS/trunk/arch/arch-X64_TITANE_VAMPIR.path	(revision 440)
@@ -11,5 +11,5 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
 
-OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"
Index: XIOS/trunk/arch/arch-XE6_LYNX.path
===================================================================
--- XIOS/trunk/arch/arch-XE6_LYNX.path	(revision 414)
+++ XIOS/trunk/arch/arch-XE6_LYNX.path	(revision 440)
@@ -11,5 +11,5 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
 
-OASIS_INCDIR="-I$WORKDIR/NEMO_COUPLE/prism/X64/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$WORKDIR/NEMO_COUPLE/prism/X64/lib"
+OASIS_INCDIR="-I$PWD/../../prism/X64/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../prism/X64/lib"
 OASIS_LIB="-lpsmile.MPI1 -lmpp_io"